<template>
  <NavBar @trigger-logout="logout" />
  <div class="container custom-body">
    <div class="row">
      <ProfileCard :user="user" :likes="this.user.likes" :dislikes="this.user.dislikes" />
      <TabSection @tab-section-liked="likePokemon" @tab-section-disliked="dislikePokemon" :token="token" />
    </div>
  </div>
  <FooterSection />
</template>

<script>
import NavBar from "../components/NavBar";
import ProfileCard from "../components/ProfileCard";
import TabSection from "../components/tabs/TabSection";
import FooterSection from "../components/FooterSection";



export default {
  name: "DashboardView",
  data() {
    return {
      user: JSON,
      token: String,
    }
  },
  async created() {
    this.token = localStorage.getItem("pokemon-bearer-token");
    if (!this.token) {
      this.$router.push('/')
    }
    else {
      const res = await fetch('http://localhost:8000/api/user', {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token}`,
        },
      })
      this.user = await res.json();

    }
  },
  components: {
    NavBar,
    ProfileCard,
    TabSection,
    FooterSection
  },
  methods: {
    async likePokemon(cardData) {
      const res = await fetch('http://localhost:8000/api/pokemon/like', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token}`,
        },
        body: JSON.stringify(cardData)

      })
      this.user = await res.json();

    },
    async dislikePokemon(cardData) {
      const res = await fetch('http://localhost:8000/api/pokemon/dislike', {
        method: 'POST',
        headers: {
          'Content-Type': 'application/json',
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token}`,
        },
        body: JSON.stringify(cardData)
      })
      this.user = await res.json();
    },
    async logout() {

      const res = await fetch('http://localhost:8000/api/logout', {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token}`,
        },
      })
      this.user = await res.json()
      localStorage.clear()
      this.$router.push('/')

    }
  },
}
</script>

<style scoped>
@import "../assets/css/custom.css";
</style>